//
//  DREncodedSoundPacket.h
//  DeepRecorder
//
//  Created by mmivi on 15.04.09.
//  Copyright 2009 DeepIT. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <CoreAudio/CoreAudio.h>
#import <AudioToolbox/AudioToolbox.h>
#import <QuickTime/QuickTime.h>

@interface DREncodedSoundPacket : NSObject {
	AudioStreamPacketDescription * _packetDescription;
	AudioBufferList * _bufferList;
	UInt32 _numberOfPackets;

}

- (id) initWihNumberBuffers: (UInt32)numBuf bufferSize: (UInt32)size numberOfChannels: (UInt32)numChan;
- (id) initInterleavedStereoBufferOfSize: (UInt32)size;
+ (id) soundPacketWithInterleavedStereoBufferOfSize: (UInt32)size;
- (void)setNeedsPacketDescriptionsForNumPackets: (UInt32)count;
- (UInt32)numberOfPackets;
- (void) dealloc;
- (AudioBufferList *)bufferList;
- (AudioStreamPacketDescription *)packetDescription;
- (long long)dataSize;
- (void)setActualNumberOfPackets: (UInt32)count;

@end
