//
//  DRPixelBuffer.h
//  DeepRecorder
//
//  Created by mmivi on 13.03.09.
//  Copyright 2009 DeepIT. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <CoreVideo/CoreVideo.h>
#import "DRQueue.h"

#define DR_PIXELBUFFER_DRAWIMAGEFORMAT_RGBA 0
#define DR_PIXELBUFFER_DRAWIMAGEFORMAT_BGRA 1

@interface DRPixelBuffer : NSObject <DRQueueObjectProtocol> {
	CVPixelBufferRef _pixelBuffer;
}

+ (void)releaseSharedPixelBufferPool;
+ (CVPixelBufferRef)createPixelBufferWithSize: (NSSize)size;

- (id)initWithSize: (NSSize)size;
+ (id)pixelBufferWithSize: (NSSize)size;

- (void)setPixelBuffer: (CVPixelBufferRef)pixBuffer;

- (long)pixelsWidth;
- (long)pixelsHeight;
- (long)bufferSize;
- (long)bytesPerRow;
- (void *)baseAddress;
- (void)lock;
- (void)unlock;

- (void)clearBuffer;

- (CVPixelBufferRef)coreVideoPixelBuffer;

-(CGImageRef)createRGBImageFromBufferData;

-(void)flipBufferContents;

//- (void)drawRGBAImage: (const unsigned char *)data :(int)size :(int)width :(int)height opacity:(float)delta atPoint: (NSPoint)point;
- (void)drawBGRAImage: (const unsigned char *)data :(int)dataBpr :(int)width :(int)height opacity:(float)delta atPoint: (NSPoint)point;
- (void)drawRGBAImage: (const unsigned char *)data :(int)dataBpr :(int)width :(int)height opacity:(float)delta atPoint: (NSPoint)point;

- (id)copyWithZone:(NSZone *)zone;

#pragma mark CITQueObjectProtocol

- (long long)dataSize;

@end
