//
//  DRSnap.h
//  DeepRecorder
//
//  Created by mmivi on 17.03.09.
//  Copyright 2009 Deep IT. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "DRMovieFrame.h"


void DRLogGLError(void);

#ifndef _CGSINTERNAL_H_

typedef int CGSConnectionID;
typedef int CGSWindowID;
typedef void* CGSRegionObj;

extern void CGSGetRegionBounds(const CGSRegionObj aRegion, CGRect *outRect);
extern OSStatus CGSGetWindowBounds(const CGSConnectionID cid, CGSWindowID wid, CGRect *bounds);
extern CGSConnectionID _CGSDefaultConnection(void);
extern void CGContextCopyWindowCaptureContentsToRect(void *grafport, CGRect rect, int cid, int wid, int zero);
extern OSStatus CGSGetSpecifiedWindowShape(const CGSConnectionID cid, const CGSWindowID wid, int mask, CGSRegionObj *shape);

#endif

@interface DRSnap : NSObject {
	NSRect _captureRect;
	NSLock * _lock;
}

- (id) initWithCaptureRect: (NSRect)rect;
- (void)setCaptureRect: (NSRect)rect;
- (void) readRectToBuffer: (DRMovieFrame *)buffer;

- (void)lockFocus;
- (void)unlockFocus;

+ (NSImage *)snapFromRect:(NSRect)rect withCursor: (BOOL)flag;
+ (void) readPartialScreenToBuffer: (NSRect)rect onScreen: (NSScreen *)screen bufferBaseAddress: (void *) baseAddress bufferBytesPerRow:(size_t) bytesPerRow;

#pragma mark Utilities

+ (NSImage *) imageFromCGImageRef: (CGImageRef)image;
+ (NSImage *)GrabWindow:(int)wid withShadow:(BOOL)flag;


@end
