//
//  DRSoundPacket.h
//  DeepRecorder
//
//  Created by mmivi on 25.03.09.
//  Copyright 2009 DeepIT. All rights reserved.
//

#import <Cocoa/Cocoa.h>

enum
{
	kSoundPacketNoFlags = 0L,
	kSoundPacketBigEndian = (1L << 0),
	kSoundPacketFloat = (1L << 1),
	kSoundPacketSignedInteger = (1L << 2),
	kSoundPacketAlignedHigh = (1L << 3)
};

typedef struct
	{
		int numberOfChannels;
		int bitsPerChannel;
		float sampleRate;
		long flags;
	} DRSoundFormat;
	
@interface DRSoundPacket : NSObject {
	void * _packetBuffer;
	int _bufferSize;
	int _numFrames;
	DRSoundFormat _format;
}

+ (id)soundPacketWithFormat: (DRSoundFormat)format numberOfFrames: (int)frames;

- (id)initWithFormat: (DRSoundFormat)format numberOfFrames: (int)frames;

- (DRSoundFormat)format;
- (void)swapByteOrder;

- (void *)baseAddres;
- (int)bufferSize;

- (long long)dataSize;

@end
